//
// PLBot - OLO's bot
//
// (http://www.olo.counter-strike.pl/)
//
// bot_nodes.cpp
//
/*
 * Copyright (c) 2004 OLO
 * This file is a part of PLBot application.
 * You are not allowed to remove these copyrights.
 */

#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include <sdk_util.h>

#include "bot.h"
#include "bot_nodes.h"
#include "plbot_api.h"  // me

node_struct node[256];
extern int parameters[MAX_PARM];
int nodes_on = 0;

void UTIL_Pathname_Convert(char *pathname)
{
   while (pathname && *pathname)
   {
#ifndef __linux__
      if (*pathname == '/')
         *pathname = '\\'; // convert to MS-DOS format
#else

      if (*pathname == '\\')
         *pathname = '/'; // convert to Linux format
#endif

      pathname++;
   }
}

bool NodesLoad()
{
   char filename[256];//Get name of file
   sprintf(filename,"cstrike/%s%s.plb",plb_wptdir->string,STRING(gpGlobals->mapname));
   UTIL_Pathname_Convert(filename);
   FILE *bfp = fopen(filename, "rb");
   //If file not exist return FALSE
   if (bfp == NULL)
      return FALSE;

   int numNodes;
   //Read parameters, nodes and number of nodes
   fread(&parameters, sizeof(parameters), 1, bfp); //Save parameters
   fread(&node, sizeof(node), 1, bfp); //Nodes
   fread(&numNodes, sizeof(numNodes), 1, bfp); //Number of nodes
   //Close file
   fclose(bfp);
   //Put nodes in map
   for (int index = 0; index < numNodes; index++)
      AddNode(node[index].origin, node[index].flags);

   if (nodes_on)
      ShowMeNode(TRUE); //Turn on nodes
   else
      ShowMeNode(FALSE); //Turn off nodes
   return TRUE;
}

void NodesSave(void)
{
   edict_t *pFoundNode = NULL;
   char filename[256];//Get name of file
   sprintf(filename,"cstrike/%s%s.plb",plb_wptdir->string,STRING(gpGlobals->mapname));
   UTIL_Pathname_Convert(filename);
   FILE *bfp = fopen(filename, "wb");
   //Counter of nodes
   int index = 0;
   //Search for nodes and save their origin
   while (pFoundNode=UTIL_FindEntityByClassname(pFoundNode, "info_node"))
   {
      node[index].origin = pFoundNode->v.origin;
      node[index].flags = pFoundNode->v.effects;
      index++; //Number of nodes
   }

   //Save parameters, nodes and their number
   fwrite(&parameters, sizeof(parameters), 1, bfp); //Save parameters
   fwrite(&node, sizeof(node), 1, bfp); //Nodes
   fwrite(&index, sizeof(index), 1, bfp); //Number of nodes
   //Close file
   fclose(bfp);
}

//Creat Navigation Node
bool AddNode(Vector origin, int iflag)
{
   edict_t *pNode = CREATE_ENTITY();
   CALL_GAME_ENTITY(PLID, "info_node", VARS(pNode));
   pNode->v.classname = MAKE_STRING("info_node");
   SET_ORIGIN(ENT(&pNode->v), origin);
   pNode->v.rendercolor.x = 255;
   pNode->v.rendercolor.y = 255;
   pNode->v.rendercolor.z = 0;
   pNode->v.rendermode = kRenderTransAdd;
   pNode->v.movetype = MOVETYPE_NONE;
   pNode->v.solid = SOLID_TRIGGER;
   SET_SIZE(ENT(&pNode->v), Vector(-8, -8, -8), Vector(8, 8, 8));
   //pNode->v.rendermode = kRenderGlow;
   pNode->v.renderfx = kRenderFxNoDissipation;
   pNode->v.renderamt = 255;
   pNode->v.scale = 0.2;
   SET_MODEL(ENT(pNode), "sprites/glow02.spr");
   pNode->v.effects = iflag;
   return TRUE;
}

edict_t *FindNearNode(edict_t *pEntity, int dist)
{
   edict_t *pFoundNode = NULL;
   while (pFoundNode = UTIL_FindEntityInSphere(pFoundNode, pEntity->v.origin, dist))
   {
      //If we have found bot lets check few cases
      if (FClassnameIs( pFoundNode, "info_node"))
         return pFoundNode;
   }

   return pFoundNode;
}

bool RemoveNode(edict_t *pEntity)
{
   edict_t *pFoundNode = FindNearNode(pEntity, 40);
   if (!pFoundNode)
      return FALSE;
   REMOVE_ENTITY(pFoundNode);
   return TRUE;
}

bool SetNodesFlag(edict_t *pEntity, int iflag)
{
   edict_t *pFoundNode = FindNearNode(pEntity, 40);
   if (!pFoundNode)
      return FALSE; //Not found node
   if (pFoundNode->v.effects & iflag)
      pFoundNode->v.effects &= ~iflag;
   else
      pFoundNode->v.effects |= iflag;

   return TRUE;
}

bool ShowMeNode(bool show)
{
   edict_t *pFoundNode = NULL;
   while (pFoundNode=UTIL_FindEntityByClassname(pFoundNode, "info_node"))
   {
      if (show)
         pFoundNode->v.effects &= ~EF_NODRAW;
      else
         pFoundNode->v.effects |= EF_NODRAW;
   }

   return TRUE;
}
