//
// PLBot - OLO's bot
//
// (http://www.olo.counter-strike.pl/)
//
// bot_weapons.cpp
//
/*
 * Copyright (c) 2004 OLO
 * This file is a part of PLBot application.
 * You are not allowed to remove these copyrights.
 */

#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include <sdk_util.h>

#include "bot.h"
#include "plbot_api.h"  // me

typedef struct
{
   int iId;    // the weapon ID value
   char weapon_name[32]; // name of the weapon when selecting it
   char name_model[32];  // name of model weapon
   float min_distance;  // 0 = no minimum
   float max_distance;  // 9999 = no maximum
   int use_percent;  // times out of 100 to use this weapon when available
   float attack_delay;  // time to charge weapon
   int rank;    // weapon rank for deciding if pick up from ground
}
bot_weapon_select_struct;

bot_weapon_select_struct bot_weapon_select[] = {

   {CS_WEAPON_SMOKEGRENADE, "weapon_smokegrenade", "models/w_smokegrenade.mdl", 400, 7000, 0,  0.0, 0},
   {CS_WEAPON_FLASHBANG,    "weapon_flashbang",    "models/w_flashbang.mdl",  400, 7000, 0,  0.0, 0},
   {CS_WEAPON_HEGRENADE,    "weapon_hegrenade",    "models/w_hegrenade.mdl",  400, 1500, 0,  0.0, 0},

   {CS_WEAPON_SCOUT,    "weapon_scout",   "models/w_scout.mdl",   70, 17000, 100, 0.0, 21},
   {CS_WEAPON_AWP,      "weapon_awp",     "models/w_awp.mdl",     70, 17000, 100, 0.0, 29},
   {CS_WEAPON_SG550,    "weapon_sg550",   "models/w_sg550.mdl",   70, 7000, 100, 0.0, 27},
   {CS_WEAPON_G3SG1,    "weapon_g3sg1",   "models/w_g3sg1.mdl",   70, 7000, 100, 0.0, 29},
   {CS_WEAPON_AUG,      "weapon_aug",     "models/w_aug.mdl",     0, 7000,  100, 0.0, 31},
   {CS_WEAPON_SG552,    "weapon_sg552",   "models/w_sg552.mdl",   0, 7000,  100, 0.0, 33},
   {CS_WEAPON_AK47,     "weapon_ak47",    "models/w_ak47.mdl",    0, 7000,  100, 0.0, 29},
   {CS_WEAPON_M4A1,     "weapon_m4a1",    "models/w_m4a1.mdl",    0, 7000,  100, 0.0, 31},
   {CS_WEAPON_FAMAS,    "weapon_famas",    "models/w_famas.mdl",    0, 7000,  100, 0.0, 28},
   {CS_WEAPON_GALIL,    "weapon_galil",    "models/w_galil.mdl",    0, 7000,  100, 0.0, 30},

   {CS_WEAPON_MP5NAVY,  "weapon_mp5navy",  "models/w_mp5.mdl",    0, 7000,  100, 0.0, 25},
   {CS_WEAPON_XM1014,   "weapon_xm1014",   "models/w_xm1014.mdl", 0, 2000,  100, 0.0, 25},
   {CS_WEAPON_M249,     "weapon_m249",     "models/w_m249.mdl",   0, 3000,  100, 0.0, 27},
   {CS_WEAPON_M3,       "weapon_m3",       "models/w_m3.mdl",     0, 1500,  100, 0.0, 27},
   {CS_WEAPON_MAC10,    "weapon_mac10",    "models/w_mac10.mdl",  0, 7000,  100, 0.0, 22},
   {CS_WEAPON_UMP45,    "weapon_ump45",    "models/w_ump45.mdl",  0, 7000,  100, 0.0, 25},

   {CS_WEAPON_TMP,      "weapon_tmp",      "models/w_tmp.mdl",     0, 7000,  100, 0.0, 22},
   {CS_WEAPON_P90,      "weapon_p90",      "models/w_p90.mdl",     0, 7000,  100, 0.0, 27},
   {CS_WEAPON_USP,      "weapon_usp",      "models/w_usp.mdl",     0, 7000,  100, 0.0, 3},
   {CS_WEAPON_GLOCK18,  "weapon_glock18",  "models/w_glock18.mdl", 0, 7000,  100, 0.0, 2},
   {CS_WEAPON_P228,     "weapon_p228",     "models/w_p228.mdl",    0, 7000,  100, 0.0, 3},
   {CS_WEAPON_ELITE,    "weapon_elite",    "models/w_elite.mdl",   0, 7000,  100, 0.0, 7},
   {CS_WEAPON_FIVESEVEN,"weapon_fiveseven","models/w_fiveseven.mdl",   0, 7000,  100, 0.0, 5},
   {CS_WEAPON_DEAGLE,   "weapon_deagle",   "models/w_deagle.mdl",      0, 7000,  100, 0.0, 7},

   {CS_WEAPON_KNIFE,    "weapon_knife",    "models/w_knife.mdl",   0, 7000,  100, 0.0, 0},
   //terminator
   {0,        "",       "",         0.0, 0.0, 0.0, 0.0, 0}
};

bool IsShooting(edict_t *pEdict)
{
   //These sequence numbers are for shoot animation
   int sequence[23] = {11,14,17,20,23,28,31,34,37,40,43,46,
                       49,52,24,27,66,67,70,71,78,81,83};
   //Get player animation
   int anim = pEdict->v.sequence;
   //By searching throught animation sequences
   //find out if player is shooting
   for (int index = 0; index < 23; index++)
   {
      if (anim == sequence[index])
         return TRUE;
   }

   //No he isn't
   return FALSE;
}

bool IsReloading(edict_t *pEdict)
{
   //These sequence numbers are for reload animation
   int sequence[23] = {12,15,18,21,24,29,32,35,38,41,44,47,
                       50,53,25,28,67,68,71,72,79,82,84};
   //Get player animation
   int anim = pEdict->v.sequence;

   //By searching throught animation sequences
   //find out if player is reloading
   for (int index = 0; index < 23; index++)
   {
      if (anim == sequence[index])
         return TRUE;
   }

   //No he isn't
   return FALSE;
}

bool SwitchToWeapon(player_t *pBot)
{
   bot_weapon_select_struct *pSelect = NULL;
   pSelect = &bot_weapon_select[0];
   int select_index = 0, your_weapon = 0;

   while (pSelect[select_index].iId)
   {
      //If you don't have called weapon from list go to next weapon
      //If your rank is better then weapon from list go to next weapon
      if ((pBot->pEdict->v.weapons & (1<<pSelect[select_index].iId)) &&
            (pSelect[your_weapon].rank < pSelect[select_index].rank))
      {
         //Save weapon and keep searching
         your_weapon = select_index;
      }

      select_index++;
   }

   if (your_weapon > 3)
   {
      FakeClientCommand(pBot->pEdict, pSelect[your_weapon].weapon_name,NULL,NULL);
      return TRUE;
   }

   return FALSE;
}

bool HaveOneZoom(player_t *pBot)
{
   //Get weapon
   int weapon = pBot->current_weapon.iId;

   //If this is an AUG or SG552 the n we have got one zoom
   if ((weapon == CS_WEAPON_AUG) || (weapon == CS_WEAPON_SG552))
      return TRUE;

   return FALSE;
}

bool HaveTwoZoom(player_t *pBot)
{
   //Set array with grenades
   int Id[4] = {CS_WEAPON_SCOUT,CS_WEAPON_AWP,CS_WEAPON_SG550, CS_WEAPON_G3SG1};
   //Get curren weapon state
   int weapon = pBot->current_weapon.iId;

   for (int index = 0; index < 4; index++)
   {
      //If have found one of this weapons in hands so we have got 2 zooms
      if (weapon == Id[index])
         return TRUE;
   }

   return FALSE; //Not found
}

bool HaveSniperRifle(player_t *pBot)
{
   //Set array with grenades
   int Id[4] = {CS_WEAPON_SG550,CS_WEAPON_G3SG1,CS_WEAPON_AWP,CS_WEAPON_SCOUT};
   //Get curren weapon state
   int weapons = pBot->pEdict->v.weapons;

   for (int index = 0; index < 4; index++)
   {
      if (weapons & (1<<Id[index])) //Found this weapon in arsenal
         return TRUE;
   }

   return FALSE; //Not found
}

bool HaveRifle(player_t *pBot)
{
   //Set array with grenades
   int Id[6] = {CS_WEAPON_AUG, CS_WEAPON_AK47, CS_WEAPON_M4A1,
                CS_WEAPON_SG552, CS_WEAPON_FAMAS, CS_WEAPON_GALIL};
   //Get current weapon state
   int weapons = pBot->pEdict->v.weapons;

   for (int index = 0; index < 6; index++)
   {
      if (weapons & (1 << Id[index])) //Found this weapon in arsenal
         return TRUE;
   }

   return FALSE; //Not found
}

bool FindBestWeaponOnGround(player_t *pBot, Vector &v_avoid_dir, float sens)
{
   edict_t *pent = NULL;
   edict_t *weapon_ground = NULL;
   bot_weapon_select_struct *pSelect = NULL;
   pSelect = &bot_weapon_select[0];
   int select_index;

   int weapon_ground_index = 0;
   int your_weapon_index = 0;
   int your_weapon_rank = 0;
   int weapon_ground_rank = 0;

   Vector v_src = pBot->pEdict->v.origin;

   //Have alrady found weapon and it he is going to it
   if ((pBot->pGroundWeapon) && (pBot->checkground_time > gpGlobals->time))
   {
      //Do we have new weapon? Is it visible?
      if (FVisible(pBot->pGroundWeapon->v.origin, pBot->pEdict))
      {
         Vector vecWeapon = pBot->pGroundWeapon->v.origin - v_src;

         //Add to main direction weapon position
         v_avoid_dir = v_avoid_dir + vecWeapon.Normalize()*(float)bsensf*sens;

         //If you are close enought, drop your weapon and forget about this on ground
         //because on 90% you have it alrady in hands;D
         if ((vecWeapon.Length() < 60) && (pBot->current_weapon.iId == pBot->your_choosed_weapon))
         {
            pBot->checkground_time = gpGlobals->time + 2;

            if (pBot->can_drop_weapon)
               FakeClientCommand(pBot->pEdict, "drop" , "" , "");

            pBot->pGroundWeapon = NULL;
         }

         return TRUE;
      }
      else //We have lost from eye our ground weapon so forget about it...
         pBot->pGroundWeapon = NULL;

   }//Try to find something better thant you have
   else if ((pBot->checkground_time < gpGlobals->time) && (CPUusage(15)))
   {
      select_index = 0;

      pBot->checkground_time = gpGlobals->time + 2;

      //Let's rank your weapon
      while (pSelect[select_index].iId)
      {
         //If you don't have called weapon from list go to next weapon
         //If your rank is better then weapon from list go to next weapon
         if ((your_weapon_rank < pSelect[select_index].rank) &&
               (pBot->pEdict->v.weapons & (1<<pSelect[select_index].iId)))
         {
            //Save weapon and keep searching
            your_weapon_rank = pSelect[select_index].rank;
            your_weapon_index = select_index;
         }
         select_index++;
      }

      //Go through weapons on ground and try to find the best
      while (pent = UTIL_FindEntityInSphere(pent, v_src, 400 ))
      {
         if (pent->v.effects & EF_NODRAW)
            continue;

         if (strcmp(STRING(pent->v.classname), "weaponbox"))
            continue;

         select_index = 0;

         while (pSelect[select_index].iId)
         {
            if ((weapon_ground_rank < pSelect[select_index].rank) &&
                  ((strcmp(STRING(pent->v.model), pSelect[select_index].name_model)) == 0))
            {
               weapon_ground_rank = pSelect[select_index].rank;
               weapon_ground_index = select_index;
               weapon_ground = pent;
            }
            select_index++;
         }
      }

      //No ammo? Your weapon is not many worth
      if ((pBot->m_rgAmmo[weapon_defs[pSelect[your_weapon_index].iId].iClip] == 0)
            && (pBot->m_rgAmmo[weapon_defs[pSelect[your_weapon_index].iId].iAmmo] == 0))
      {
         //If no ammo for primary give 1 points
         if (your_weapon_rank < 10)
            your_weapon_rank = 1;
         else //The worths from secondary weapons
            your_weapon_rank = 20;
      }

      //Well well we have found better weapon
      if (your_weapon_rank < weapon_ground_rank)
      {
         //Remember this weapon
         pBot->pGroundWeapon = weapon_ground;
         pBot->your_choosed_weapon = pSelect[your_weapon_index].iId;

         //Swith to your weapon if haven't it in hands
         if (pBot->current_weapon.iId != pBot->your_choosed_weapon)
            FakeClientCommand(pBot->pEdict, pSelect[your_weapon_index].weapon_name,NULL,NULL);

         //If this is not the same type, you can't drop your current one
         if (abs(weapon_ground_rank - your_weapon_rank) < 14)
            pBot->can_drop_weapon = TRUE;
      }
   }

   //Return going direction
   return FALSE;
}

bool BotFireWeapon(float distance, player_t *pBot, int weapon_choice)
{
   bot_weapon_select_struct *pSelect = NULL;
   pSelect = &bot_weapon_select[0];
   int iId, select_index = 0;

   //We have got enought ammo so attack enemy
   if ((pBot->current_weapon.iClip > 0) || (pBot->current_weapon.iAmmo == -1))
   {
      pBot->pEdict->v.button |= IN_ATTACK;
      return TRUE;
   }
   //We have got to reload weapon
   else if ((pBot->current_weapon.iClip == 0) && (pBot->current_weapon.iAmmo > 0))
   {
      pBot->action_time = gpGlobals->time;
      pBot->pEdict->v.button |= IN_RELOAD;
      return TRUE;
   }

   //This timelimit make bot choosing weapon slower
   if (pBot->weap_change_time > gpGlobals->time)
      return FALSE;

   pBot->weap_change_time = gpGlobals->time + 2;

   // loop through all the weapons until terminator is found...
   while (pSelect[select_index].iId)
   {
      // was a weapon choice specified? (and if so do they NOT match?)
      if ((weapon_choice > 0) && (weapon_choice != pSelect[select_index].iId))
      {
         select_index++;  // skip to next weapon
         continue;
      }

      // if bot don't have this weapon in his arsenal
      if ((pBot->pEdict->v.weapons & (1<<pSelect[select_index].iId)) == FALSE)
      {
         select_index++;  // skip to next weapon
         continue;
      }

      // Usage percent
      if ((weapon_choice == 0) && ((RANDOM_LONG(1, 100) > pSelect[select_index].use_percent)))
      {
         select_index++;  // skip to next weapon
         continue;
      }

      //If the distance not match skip weapon
      if ((weapon_choice == 0) && ((distance < pSelect[select_index].min_distance) ||
                                   (distance > pSelect[select_index].max_distance)))
      {
         select_index++;
         continue;
      }

      iId = pSelect[select_index].iId;

      //If have enought ammo and the distance is good use this weapon
      if ((weapon_defs[iId].iAmmo != -1) && (pBot->m_rgAmmo[weapon_defs[iId].iAmmo] == 0) &&
            (pBot->m_rgAmmo[weapon_defs[iId].iClip] == 0))
      {
         select_index++;
         continue;
      }

      //If don't have this weapon in hand, select it
      if (pBot->current_weapon.iId != iId)
      {
         //Switch to selected weapon if not current used
         FakeClientCommand(pBot->pEdict, pSelect[select_index].weapon_name,NULL,NULL);

         //Apply delay which is for switching weapons (especialy grenades)
         pBot->shoot_time = gpGlobals->time + pSelect[select_index].attack_delay;
      }

      select_index++;//return FALSE;
   }

   return FALSE;
}

bool DecideToThrowGrenade(player_t *pBot)
{
   if (pBot->check_grenade > gpGlobals->time)
      return FALSE;

   //Won't check again
   pBot->check_grenade = gpGlobals->time + 0.5;

   //No, don't throw - randomization
   if (Chance(1))
      return FALSE;

   Vector vecTarget = pBot->last_enemy_pos;
   Vector vecSrc = pBot->pEdict->v.origin;
   float enemyLevel = vecTarget.z - vecSrc.z;
   float enemyDist = (pBot->pBotEnemy->v.origin - vecSrc).Length();

   if ( enemyLevel < -200)
      return FALSE; //Well bot is below so don' throw grenade

   TraceResult tr_end;

   UTIL_TraceLine(vecSrc , vecTarget + Vector(0,0,enemyLevel), dont_ignore_monsters, dont_ignore_glass,
                  pBot->pEdict->v.pContainingEntity, &tr_end);

   if ((enemyDist < 500) || ( enemyDist > (tr_end.vecEndPos - vecSrc).Length() + 300))
      return FALSE; //too close

   //If enemy hide and not visible for one second throw grenade
   if ((pBot->pEdict->v.weapons & (1<<CS_WEAPON_HEGRENADE)) && ((pBot->bot_action & player_tHROW_HG) == FALSE))
   {
      //Set throw HEGrenade
      pBot->bot_action |= player_tHROW_HG;
      pBot->check_grenade = gpGlobals->time + 7;

      return TRUE;
   }
   else if ((pBot->pEdict->v.weapons & (1<<CS_WEAPON_FLASHBANG)) && ((pBot->bot_action & player_tHROW_FG) == FALSE))
   {
      //Set throw HEGrenade
      pBot->bot_action |= player_tHROW_FG;
      pBot->check_grenade = gpGlobals->time + 7;

      return TRUE;
   }
   else if ((pBot->pEdict->v.weapons & (1<<CS_WEAPON_SMOKEGRENADE)) && ((pBot->bot_action & player_tHROW_SG) == FALSE))
   {
      //Set throw HEGrenade
      pBot->bot_action |= player_tHROW_SG;
      pBot->check_grenade = gpGlobals->time + 7;

      return TRUE;
   }

   return FALSE;
}

bool ThrowGrenade(player_t *pBot)
{
   //Now check if we alrady have grenade in hand
   if (HaveGrenadeInHand(pBot))
   {
      Vector vecSrc = pBot->pEdict->v.origin;
      TraceResult tr_end_aim;

      //Fast shooting on/off to throw grenade
      if (pBot->is_shooting > 1)
      {
         pBot->is_shooting = 0;
         pBot->pEdict->v.button |= IN_ATTACK;
      }
      else if (IsThrowingGrenade(pBot->pEdict) == FALSE) //We are throwing grenade so don't keep firing
         pBot->is_shooting++; //Turn off don't shoot

      Vector vecTarget = pBot->last_enemy_pos;

      Vector vecAim = vecTarget + Vector(0,0,(vecTarget.z - vecSrc.z) + ((vecTarget - vecSrc).Length2D()/4)) - vecSrc;

      pBot->pEdict->v.v_angle = BotPointAt(pBot, vecAim, TRUE);

      return TRUE;
   }
   else if (pBot->bot_action & player_tHROW_HG) //Have hegrenade bit so throw it!
   {
      FakeClientCommand(pBot->pEdict, "weapon_hegrenade",NULL,NULL);
      pBot->bot_action &= ~player_tHROW_HG; //Remove bit

      return TRUE;
   }
   else if (pBot->bot_action & player_tHROW_SG) //Have sggrenade bit so throw it!
   {
      FakeClientCommand(pBot->pEdict, "weapon_smokegrenade",NULL,NULL);
      pBot->bot_action &= ~player_tHROW_SG;

      return TRUE;
   }
   else if (pBot->bot_action & player_tHROW_FG) //Have flashgrenade bit so throw it!
   {
      FakeClientCommand(pBot->pEdict, "weapon_flashbang",NULL,NULL);
      pBot->bot_action &= ~player_tHROW_FG;

      return TRUE;
   }

   //We don't have to throw grenade so return FALSE
   return FALSE;
}

bool CheckForSmokeGrenade(player_t *pBot, float distance)
{
   //Serach for smokegreande lying on ground
   edict_t *pFoundItem = Finditem(pBot, pBot->pEdict->v.origin, "models/w_smokegrenade.mdl", CLIENT_ALLTEAMS, 2000, FALSE);

   if (pFoundItem)
   {
      Vector vecSG = pFoundItem->v.origin - pBot->pEdict->v.origin;
      float distSG = vecSG.Length();

      //If smoke grenade is 100 unit far or it is just in angle of view and is visible make
      //bots not visible through it (return TRUE)
      if ((distSG < distance + 50) && ((InFieldOfView( pBot, vecSG, pBot->pEdict->v.angles.y) < 45) && FVisible(pFoundItem->v.origin, pBot->pEdict)))
         return TRUE;
   }

   return FALSE;
}
